@use "sass:math";
@import "../../styles/_keyframes.scss";
@import "../../styles/_typefaces.scss";
@import "../../styles/_variables.scss";

// Loom.
.loom {
	margin: 0.4rem 0;

	// Loom header.
	> .loom_header {
		margin: 0 0 0.4rem;
		display: flex;

		// Prevent height collapse.
		* {
			min-height: 1.15em;
		}

		// Place.
		.place {
			flex: 1;
			white-space: nowrap;
			overflow: hidden;
			text-overflow: ellipsis;

			animation: fade_in 1s ease-out;
			transition: color 1s ease;
		}

		// Time.
		.time {
			margin-left: 0.8rem;

			animation: fade_in 1s ease-out;
			transition: color 1s ease;
		}
	}

	// Hibiol.
	> .Hibiol {
		box-sizing: border-box;
		height: $Hibiol_height;
		border-radius: $border_radius;
		padding: 0 $event_min_width/2;
		overflow: hidden;

		transition: background-color 1s ease;

		// Hibiol wrapper.
		> .wrapper {
			position: relative;
			height: 100%;
			display: flex;
			align-items: center;

			// Event.
			> .event {
				position: absolute;
				margin-left: -$event_min_width/2;
				height: $event_height;
				min-width: $event_min_width;

				/*
					Approximate a band-pass filter with normal skirts, height 1, and width 1 centered at 0.5 using √(2Π(σ^2))⋅N(0, 1) (scaled standard normal distribution).
				*/

				// Maximum opacity.
				$max_opacity: 0.6;
				// Skirt width as a proportion of filter width.
				$skirt_width: 0.3;

				// Left skirt.
				$filter: ();
				$filter: append($filter, transparent 0%, comma);
				@for $x from -3 / 0.1 + 1 through 0 {
					$x_p: $x * 0.1;
					$opacity: math.clamp(0, $max_opacity, 1) * math.pow(math.$e, -1 * math.pow($x_p, 2) / 2);
					$position: (($x_p / 3 + 1) * math.clamp(0, $skirt_width, 0.5)) * 100%;
					$filter: append($filter, hsla(0, 0%, 100%, $opacity) $position, comma);
				}
				// Right skirt.
				@for $x from 0 to 3 / 0.1 {
					$x_p: $x * 0.1;
					$opacity: math.clamp(0, $max_opacity, 1) * math.pow(math.$e, -1 * math.pow($x_p, 2) / 2);
					$position: (1 - (1 - $x_p / 3) * math.clamp(0, $skirt_width, 0.5)) * 100%;
					$filter: append($filter, hsla(0, 0%, 100%, $opacity) $position, comma);
				}
				$filter: append($filter, transparent 100%, comma);

				mask-image: linear-gradient(0deg, $filter);
				mask-mode: alpha;

				animation: fade_in 1s ease-out;
				transition: width 1s ease, background-color 1s ease;
			}
		}
	}
}